<?php
// $Id: xc_auth.ldap.inc,v 1.1.2.6 2010/06/11 21:35:24 pkiraly Exp $

// LDAP INTEGRATION EXPERIMENTAL!!!

function xc_auth_method_ldap_form(&$form_state) {
  $result = db_query("SELECT sid, name FROM {ldapauth}");

  $servers = array();
  while ($server = db_fetch_object($result)) {
    $servers[$server->sid] = $server->name;
  }

  $form['sid'] = array(
    '#type' => 'checkboxes',
    '#title' => t('LDAP Server(s)'),
    '#options' => $servers
  );

  return $form;
}

function xc_auth_method_ldap_validate($form, &$from_state) {}
function xc_auth_method_ldap_submit($form, &$from_state) {}

function xc_auth_method_login_ldap_validate($form, &$from_state) {}
function xc_auth_method_login_ldap_submit($form, &$from_state) {}

/**
 * This is practically a copy of the functions from the LDAP Integration
 * module to prevent conflict with that module's LDAP object instance
 */
function xc_auth_ldap_authenticate($sid, $user, $pass) {
  global $xc_auth_ldap_enabled;

  if (!$xc_auth_ldap_enabled) {
    return FALSE;
  }

  $result = db_query("SELECT sid FROM {ldapauth} WHERE status = 1 ORDER BY weight");
  while ($row = db_fetch_object($result)) {
    if (!xc_ldap_server_init($row->sid))
      return FALSE;

    if (!($ldap = xc_auth_ldap_user_lookup($user)) || !isset($ldap['dn']))
      continue;

    if (($code = xc_auth_ldap_info($row->sid, 'filter_php')) && !eval($code))
      continue;

    if (!$xc_auth_ldap->connect($ldap['dn'], $pass))
      continue;

    return $ldap['dn'];
  }
  return FALSE;
}

function xc_ldap_server_init($sid) {
  global $xc_auth_ldap;

  static $servers = array();
  if (!isset($servers[$sid]))
    $servers[$sid] = db_fetch_object(db_query("SELECT * FROM {ldapauth} WHERE status = 1 AND sid = %d", $sid));

  if ($servers[$sid]) {
    $xc_auth_ldap = new LDAPInterface();
    $xc_auth_ldap->setOption('sid', $sid);
    $xc_auth_ldap->setOption('name', $servers[$sid]->name);
    $xc_auth_ldap->setOption('server', $servers[$sid]->server);
    $xc_auth_ldap->setOption('port', $servers[$sid]->port);
    $xc_auth_ldap->setOption('tls', $servers[$sid]->tls);
    $xc_auth_ldap->setOption('encrypted', $servers[$sid]->encrypted);
    $xc_auth_ldap->setOption('basedn', $servers[$sid]->basedn);
    $xc_auth_ldap->setOption('user_attr', $servers[$sid]->user_attr);
    $xc_auth_ldap->setOption('mail_attr', $servers[$sid]->mail_attr);
    $xc_auth_ldap->setOption('binddn', $servers[$sid]->binddn);
    $xc_auth_ldap->setOption('bindpw', $servers[$sid]->bindpw);
  }
}

function xc_auth_ldap_user_lookup($user) {
  global $xc_auth_ldap;

  if (!$xc_auth_ldap)
    return;

  $login_name = ($code = xc_auth_ldap_info($xc_auth_ldap->getOption('sid'), 'login_php')) ? eval($code) : $user;

  $xc_auth_ldap->connect($xc_auth_ldap->getOption('binddn'), $xc_auth_ldap->getOption('bindpw'));
  foreach (explode("\r\n", $xc_auth_ldap->getOption('basedn')) as $base_dn) {
    if (empty($base_dn))
      continue;

    $user_attr = $xc_auth_ldap->getOption('user_attr') ? $xc_auth_ldap->getOption('user_attr') : LDAPAUTH_DEFAULT_USER_ATTR;
    $filter = $user_attr .'='. $login_name;
    $result = $xc_auth_ldap->search($base_dn, $filter);
    if (!$result)
      continue;

    $num_matches = $result['count'];
    if ($num_matches != 1) {
      watchdog('ldapauth', "Error: %num_matches users found with $%filter under %base_dn.", 
        array(
          '%num_matches' => $num_matches, 
          '%filter' => $filter, 
          '%base_dn' => $base_dn
        ), WATCHDOG_ERROR);
      continue;
    }
    $match = $result[0];

    if (!isset($match[$user_attr][0])) {
      $user_attr = drupal_strtolower($user_attr);
      if (!isset($match[$user_attr][0]))
        continue;
    }

    foreach ($match[$user_attr] as $value) {
      if (drupal_strtolower(trim($value)) == drupal_strtolower($login_name))
        return $match;
    }
  }
}

function xc_auth_ldap_info($sid, $req) {
  static $servers = array();
  if (!isset($servers[$sid]))
    $servers[$sid] = db_fetch_object(db_query("SELECT * FROM {ldapauth} WHERE sid = %d", $sid));

  switch ($req) {
    case 'login_php':
      return $servers[$sid]->login_php;
    case 'filter_php':
      return $servers[$sid]->filter_php;
  }
}